//
// SavedSearch.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct SavedSearch: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var memberKeyNumeric: Double?
    public var savedSearchKeyNumeric: Double?
    public var memberKey: String?
    public var memberMlsId: String?
    public var originatingSystemID: Double?
    public var originatingSystemKey: String?
    public var originatingSystemMemberKey: String?
    public var originatingSystemMemberName: String?
    public var originatingSystemName: String?
    public var savedSearchDescription: String?
    public var savedSearchKey: String?
    public var savedSearchName: String?
    public var searchQuery: String?
    public var searchQueryExceptionDetails: String?
    public var searchQueryHumanReadable: String?
    public var sourceSystemID: Double?
    public var sourceSystemKey: String?
    public var sourceSystemName: String?
    public var className: String?
    public var resourceName: String?
    public var savedSearchType: String?
    public var searchQueryExceptions: String?
    public var searchQueryType: String?
    public var modificationTimestamp: Date?
    public var originalEntryTimestamp: Date?
    public var member: Member?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?
    public var prospectings: [Prospecting]?

    public init(id: Int? = nil, memberKeyNumeric: Double? = nil, savedSearchKeyNumeric: Double? = nil, memberKey: String? = nil, memberMlsId: String? = nil, originatingSystemID: Double? = nil, originatingSystemKey: String? = nil, originatingSystemMemberKey: String? = nil, originatingSystemMemberName: String? = nil, originatingSystemName: String? = nil, savedSearchDescription: String? = nil, savedSearchKey: String? = nil, savedSearchName: String? = nil, searchQuery: String? = nil, searchQueryExceptionDetails: String? = nil, searchQueryHumanReadable: String? = nil, sourceSystemID: Double? = nil, sourceSystemKey: String? = nil, sourceSystemName: String? = nil, className: String? = nil, resourceName: String? = nil, savedSearchType: String? = nil, searchQueryExceptions: String? = nil, searchQueryType: String? = nil, modificationTimestamp: Date? = nil, originalEntryTimestamp: Date? = nil, member: Member? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil, prospectings: [Prospecting]? = nil) {
        self.id = id
        self.memberKeyNumeric = memberKeyNumeric
        self.savedSearchKeyNumeric = savedSearchKeyNumeric
        self.memberKey = memberKey
        self.memberMlsId = memberMlsId
        self.originatingSystemID = originatingSystemID
        self.originatingSystemKey = originatingSystemKey
        self.originatingSystemMemberKey = originatingSystemMemberKey
        self.originatingSystemMemberName = originatingSystemMemberName
        self.originatingSystemName = originatingSystemName
        self.savedSearchDescription = savedSearchDescription
        self.savedSearchKey = savedSearchKey
        self.savedSearchName = savedSearchName
        self.searchQuery = searchQuery
        self.searchQueryExceptionDetails = searchQueryExceptionDetails
        self.searchQueryHumanReadable = searchQueryHumanReadable
        self.sourceSystemID = sourceSystemID
        self.sourceSystemKey = sourceSystemKey
        self.sourceSystemName = sourceSystemName
        self.className = className
        self.resourceName = resourceName
        self.savedSearchType = savedSearchType
        self.searchQueryExceptions = searchQueryExceptions
        self.searchQueryType = searchQueryType
        self.modificationTimestamp = modificationTimestamp
        self.originalEntryTimestamp = originalEntryTimestamp
        self.member = member
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
        self.prospectings = prospectings
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case memberKeyNumeric = "MemberKeyNumeric"
        case savedSearchKeyNumeric = "SavedSearchKeyNumeric"
        case memberKey = "MemberKey"
        case memberMlsId = "MemberMlsId"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemKey = "OriginatingSystemKey"
        case originatingSystemMemberKey = "OriginatingSystemMemberKey"
        case originatingSystemMemberName = "OriginatingSystemMemberName"
        case originatingSystemName = "OriginatingSystemName"
        case savedSearchDescription = "SavedSearchDescription"
        case savedSearchKey = "SavedSearchKey"
        case savedSearchName = "SavedSearchName"
        case searchQuery = "SearchQuery"
        case searchQueryExceptionDetails = "SearchQueryExceptionDetails"
        case searchQueryHumanReadable = "SearchQueryHumanReadable"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemKey = "SourceSystemKey"
        case sourceSystemName = "SourceSystemName"
        case className = "ClassName"
        case resourceName = "ResourceName"
        case savedSearchType = "SavedSearchType"
        case searchQueryExceptions = "SearchQueryExceptions"
        case searchQueryType = "SearchQueryType"
        case modificationTimestamp = "ModificationTimestamp"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case member = "Member"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
        case prospectings = "Prospectings"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(memberKeyNumeric, forKey: .memberKeyNumeric)
        try container.encodeIfPresent(savedSearchKeyNumeric, forKey: .savedSearchKeyNumeric)
        try container.encodeIfPresent(memberKey, forKey: .memberKey)
        try container.encodeIfPresent(memberMlsId, forKey: .memberMlsId)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemKey, forKey: .originatingSystemKey)
        try container.encodeIfPresent(originatingSystemMemberKey, forKey: .originatingSystemMemberKey)
        try container.encodeIfPresent(originatingSystemMemberName, forKey: .originatingSystemMemberName)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(savedSearchDescription, forKey: .savedSearchDescription)
        try container.encodeIfPresent(savedSearchKey, forKey: .savedSearchKey)
        try container.encodeIfPresent(savedSearchName, forKey: .savedSearchName)
        try container.encodeIfPresent(searchQuery, forKey: .searchQuery)
        try container.encodeIfPresent(searchQueryExceptionDetails, forKey: .searchQueryExceptionDetails)
        try container.encodeIfPresent(searchQueryHumanReadable, forKey: .searchQueryHumanReadable)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemKey, forKey: .sourceSystemKey)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(className, forKey: .className)
        try container.encodeIfPresent(resourceName, forKey: .resourceName)
        try container.encodeIfPresent(savedSearchType, forKey: .savedSearchType)
        try container.encodeIfPresent(searchQueryExceptions, forKey: .searchQueryExceptions)
        try container.encodeIfPresent(searchQueryType, forKey: .searchQueryType)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(member, forKey: .member)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
        try container.encodeIfPresent(prospectings, forKey: .prospectings)
    }
}

